# coding: utf-8

# flake8: noqa

"""
    Callchimp Public API

    ## Introduction👋 Introducing OpenAPI spec for doing almost anything in [callchimp.ai](https://callchimp.ai). CallChimp is a Gen AI Call Center Enhancing telecommunication with GPT-driven bulk calling. It is scalable, user-friendly, and customizable. Optimized for seamless integration and usability. ## API Categories📋 The APIs are divided in 7 categories listed below:   - Campaigns   - Supervisors   - Lists   - Subscribers   - Calls   - Phone Numbers   - Webhooks  ## API Operations✅ ### Campaign Operations    - List all Campaigns   - Create a Campaign   - Get Campaign by Id   - Delete Campaign by Id   - Update Campaign by Id   - Add Supervisors to Campaign by Id   - Remove Supervisors from Campaign by Id   - Upload audio file to Campaign by Id  ### Supervisor Operations    - List all Supervisors   - Create a Supervisor   - Get Supervisor by Id   - Delete Supervisor by Id   - Update Supervisor by Id   - Send OTP to Campaign by Id   - Verify Supervisor OTP by Id  ### List Operations    - List all Lists   - Create a List   - Get List by Id   - Delete List by Id   - Update List by Id  ### Subscriber Operations    - List all Subscribers   - Create one or more Subscriber(s)   - Get Subscriber by Id   - Delete Subscriber by Id   - Update Subscriber by Id  ### Call Operations    - List outbound Calls   - Create a Call   - Get Call by Id   - List Inbound Calls   - Generate Call Reports  ### Phone Number Operations    - List Phone Numbers  ### Webhook Operations    - List all Webhooks   - Create a Webhook   - Get Webhook by Id   - Delete Webhook by Id   - Update Webhook by Id  ## Authentication🔐 CallChimp public API offers authentication with API Keys. All endpoints accepts a header named `x-api-key`. To get started follow the below steps:    1. Login to callchimp dashboard.   2. Click on your profile on the top-right corner.   3. Click on Settings.   4. On the settings page, click on `API Keys` from the left sidebar.   5. Click on `Add new` button, add an expiry date and click on `Add`.   6. An API Key will be generated, please save the key somewhere safe as it won't be shown again!   7. You can use the API Key directly here in this playground to test out the APIs. 

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


__version__ = "1.0.0"

# import apis into sdk package
from callchimp.api.calls_api import CallsApi
from callchimp.api.campaigns_api import CampaignsApi
from callchimp.api.lists_api import ListsApi
from callchimp.api.phone_numbers_api import PhoneNumbersApi
from callchimp.api.subscribers_api import SubscribersApi
from callchimp.api.supervisors_api import SupervisorsApi
from callchimp.api.webhooks_api import WebhooksApi

# import ApiClient
from callchimp.api_response import ApiResponse
from callchimp.api_client import ApiClient
from callchimp.configuration import Configuration
from callchimp.exceptions import OpenApiException
from callchimp.exceptions import ApiTypeError
from callchimp.exceptions import ApiValueError
from callchimp.exceptions import ApiKeyError
from callchimp.exceptions import ApiAttributeError
from callchimp.exceptions import ApiException

# import models into sdk package
from callchimp.models.call_list_response import CallListResponse
from callchimp.models.call_report_request import CallReportRequest
from callchimp.models.call_report_response import CallReportResponse
from callchimp.models.call_report_response_answered_calls import CallReportResponseAnsweredCalls
from callchimp.models.call_report_response_stats_inner import CallReportResponseStatsInner
from callchimp.models.call_request_by_lead_id import CallRequestByLeadId
from callchimp.models.call_request_by_vendor_lead_code import CallRequestByVendorLeadCode
from callchimp.models.call_response import CallResponse
from callchimp.models.campaign_add_super_request import CampaignAddSuperRequest
from callchimp.models.campaign_add_super_response import CampaignAddSuperResponse
from callchimp.models.campaign_list_response import CampaignListResponse
from callchimp.models.campaign_remove_super_request import CampaignRemoveSuperRequest
from callchimp.models.campaign_remove_super_response import CampaignRemoveSuperResponse
from callchimp.models.campaign_request import CampaignRequest
from callchimp.models.campaign_response import CampaignResponse
from callchimp.models.campaign_upload_audio_response import CampaignUploadAudioResponse
from callchimp.models.inbound_call_list_response import InboundCallListResponse
from callchimp.models.inbound_call_response import InboundCallResponse
from callchimp.models.inbound_call_response_callchimp_number import InboundCallResponseCallchimpNumber
from callchimp.models.inbound_call_response_hangup_cause import InboundCallResponseHangupCause
from callchimp.models.inbound_call_response_supervisor import InboundCallResponseSupervisor
from callchimp.models.lists_list_response import ListsListResponse
from callchimp.models.lists_request import ListsRequest
from callchimp.models.lists_response import ListsResponse
from callchimp.models.phone_number_list_response import PhoneNumberListResponse
from callchimp.models.phone_number_response import PhoneNumberResponse
from callchimp.models.post_dev_calls_request import PostDevCallsRequest
from callchimp.models.subscriber_list_response import SubscriberListResponse
from callchimp.models.subscriber_request import SubscriberRequest
from callchimp.models.subscriber_response import SubscriberResponse
from callchimp.models.subscribers_update import SubscribersUpdate
from callchimp.models.supervisor_list_response import SupervisorListResponse
from callchimp.models.supervisor_request import SupervisorRequest
from callchimp.models.supervisor_response import SupervisorResponse
from callchimp.models.supervisor_send_otp_response import SupervisorSendOtpResponse
from callchimp.models.supervisor_verify_otp_request import SupervisorVerifyOtpRequest
from callchimp.models.supervisor_verify_otp_response import SupervisorVerifyOtpResponse
from callchimp.models.webhook_list_response import WebhookListResponse
from callchimp.models.webhook_request import WebhookRequest
from callchimp.models.webhook_response import WebhookResponse
